#!/usr/local/bin/python
#
'''Blogch2.

Simble Blog Edit Tool.
'''
#
# Copyright (c) 2006 Satoshi Fukutomi <info@fuktommy.com>.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#

import cgitb; cgitb.enable()

import re
import os
import cgi
import sys
import time
import urllib

sys.path.append('/virtual/fuktommy/private/python')
import blogdata
from blogdata import *

#
# Config
#
#baseuri = './?'
#rsspath = './rss.rdf'
#sitemappath = './sitemap.txt'
#blogdata.data_dir = './data'
blogdata.data_dir = '../data'
baseuri = '/'
rsspath = '../rss.rdf'
sitemappath = '../sitemap.txt'
timezone = 'JST-09'
w3ctimezone = '+09:00'
bloguri = 'http://blog.fuktommy.com/'
blogtitle = 'blog.fuktommy.com'
blogdesc = 'Blog of Fuktommy'
rssuri = 'http://blog.fuktommy.com/rss'
creator = 'Fuktommy'
rsssize = 15
descsize = 300

def permalink(id):
    return '%s%s' % (bloguri, id)

def print_header():
    print '''Content-Type: text/html; charset=UTF-8

<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
  <meta http-equiv="content-type" content="text/html; charset=UTF-8" />
  <title>EDIT</title>
  <link rev="made" href="mailto:webmaster@fuktommy.com" />
  <link rel="contents" href="/blog" title="Top" />
  <link rel="stylesheet" type="text/css" href="/pc.css" />
  <link rel="meta" type="application/rdf+xml" title="license" href="/license" />
</head>
<body>
<h1>EDIT <a href="%s">%s</a></h1>''' % \
        (cgi.escape(baseuri), cgi.escape(blogtitle))

def error(msg='Something wrong'):
    print 'Content-Type: text/plain; charset=UTF-8'
    print
    print msg
    sys.exit(0)

def print_edit(id="", title="", body=""):
    print_header()
    xtitle =  cgi.escape(title)
    if xtitle:
        xtitle += '\n\n'
    print '<h2><a href="%s%s">%s</a></h2>' % (baseuri, id, title)
    print '''<form method="post" action="./edit.cgi" id="edit"><p>
<input type="submit" value="SAVE" />
<input type="submit" value="PREVIEW" onclick="return preview();" />
<input type="hidden" name="id" value="%s" />
<br />
<textarea name="data" cols="80" rows="20" style="width: 90%%;">%s%s</textarea>
</p></form>
<div id="preview"></div>
<script type="text/javascript">
// <![CDATA[
function preview() {
    var prev = document.getElementById('preview');
    var edit = document.getElementById('edit');
    prev.innerHTML = edit.data.value;
    return false;
}
// ]]>
</script>
</body></html>''' % (id, xtitle, cgi.escape(body))


def update_recent():
    entries = []
    index = Index()
    index.load()
    for m in index:
        month = Month(m)
        month.load()
        for id, title in month:
            entry = Entry(id)
            entry.load()
            entries.append(entry)
            if rsssize < len(entries):
                break
        if rsssize < len(entries):
            break
    entries.sort(lambda a,b: cmp(b.id, a.id))
    set_recent_entry(entries[0])
    f = file(rsspath, 'wb')
    f.write('''<?xml version="1.0" encoding="UTF-8"?>
<?xml-stylesheet href="/rss1.xsl" type="text/xsl"?>
<rdf:RDF
  xmlns="http://purl.org/rss/1.0/"
  xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
  xmlns:content="http://purl.org/rss/1.0/modules/content/"
  xmlns:dc="http://purl.org/dc/elements/1.1/"
  xmlns:cc="http://web.resource.org/cc/"
  xml:lang="ja">
<channel rdf:about="%s">
   <title>%s</title>
   <link>%s</link>
   <description>%s</description>
   <dc:creator>%s</dc:creator>
   <items><rdf:Seq>
''' % (cgi.escape(rssuri, True),
       cgi.escape(blogtitle),
       cgi.escape(bloguri),
       cgi.escape(blogdesc),
       cgi.escape(creator)))
    for e in entries:
        f.write('<rdf:li rdf:resource="%s"/>\n' % permalink(e.id))
    f.write('</rdf:Seq></items></channel>\n')
    for e in entries:
        e.load()
        desc = unicode(e.body, 'utf-8')
        desc = re.sub(r'<.*?>|\s+', ' ', desc)
        desc = desc[:descsize].encode('utf-8')
        f.write('''<item rdf:about="%s%d">
<title>%s</title>
<link>%s</link>
<dc:date>%s%s</dc:date>
<dc:creator>%s</dc:creator>
<dc:rights>http://creativecommons.org/licenses/by/2.1/jp/</dc:rights>
<cc:license rdf:resource="%s"/>
<description>%s</description>
<content:encoded><![CDATA[%s]]></content:encoded>
</item>''' % (cgi.escape(bloguri),
              e.id,
              cgi.escape(e.title),
              permalink(e.id),
              time.strftime('%Y-%m-%dT%H:%M:%S', time.localtime(e.id)),
              w3ctimezone,
              cgi.escape(creator),
              permalink(e.id),
              cgi.escape(desc),
              e.body))
    f.write('</rdf:RDF>')

def update_sitemap():
    f = file(sitemappath, 'w')
    f.write(bloguri + '\n')
    index = Index()
    index.load()
    for m in index:
        month = Month(m)
        month.load()
        for id, title in month:
            entry = Entry(id)
            f.write(permalink(id) + '\n')

def save_data(id, data):
    if not id:
        id = time.time()
    elif not re.search(r'^\d+$', id):
        error('%s: Wrong ID' % id)
    entry = Entry(id)
    month = Month(entry.month())
    month.load()
    if (not data) and entry.exists():
        entry.remove()
        if not month:
            month.remove()
    else:
        buf = data.splitlines()
        entry.title = buf[0].strip()
        entry.body = '\n'.join(buf[1:]).strip() + '\n'
        entry.sync()
        month.update()
    update_recent()
    update_sitemap()


def main():
    os.environ['TZ'] = timezone
    time.tzset()
    form = cgi.FieldStorage()
    data = form.getfirst('data', '').strip()
    id = form.getfirst('id', '')
    query = os.environ.get('QUERY_STRING', '')
    found_entry = re.search(r'^(\d+)$', query)
    if found_entry:
        entry = Entry(found_entry.group(1))
        entry.load()
        print_edit(entry.id, entry.title, entry.body)
    elif id or data:
        save_data(id, data)
        print_edit()
    else:
        print_edit()

if __name__ == '__main__':
    main()
