#!/usr/local/bin/python
#
'''Blogch2.

Simble Blog Tool.
'''
#
# Copyright (c) 2006,2007 Satoshi Fukutomi <info@fuktommy.com>.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#

import cgitb; cgitb.enable()

import re
import os
import cgi
import sys
import time
import urllib

sys.path.append('/virtual/fuktommy/private/python')
from blogdata import *

#
# Config
#
#baseuri = './?'
baseuri = '/'
timezone = 'JST-09'
bloguri = 'http://blog.fuktommy.com/'
blogtitle = 'blog.fuktommy.com'
rssuri = 'http://blog.fuktommy.com/rss'
mobileuri = 'http://mobile.fuktommy.com/blog/'


def permalink(id):
    return '%s%s' % (bloguri, id)

def print_header(title, pathname, top=False):
    title = cgi.escape(title, True)
    if top:
        cssname = 'toppc'
    else:
        cssname = 'pc'
    print '''Content-Type: text/html; charset=UTF-8

<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
  <meta http-equiv="content-type" content="text/html; charset=UTF-8" />
  <title>%s</title>
  <link rev="made" href="http://fuktommy.com/" />
  <link rel="contents" href="/" title="Top" />
  <link rel="stylesheet" type="text/css" href="/mobile.css"
        media="handheld" />
  <link rel="stylesheet" type="text/css" href="/%s.css"
        media="screen,tv" />
  <link rel="stylesheet" type="text/css" href="/print.css"
        media="print,projection " />
  <link rel="alternate" media="handheld" href="%s%s" />
  <link rel="alternate" type="application/rss+xml" title="RSS" href="%s" />
  <link rel="meta" type="application/rdf+xml" title="license" href="/license" />
</head>
<body>
<h1><a href="%s"><span style="color:#30a72f">b</span><span style="color:#c41200">l</span><span style="color:#0039b6">o</span><span style="color:#c41200">g</span><span style="color:#f3c518">.</span><span style="color:#0039b6">f</span><span style="color:#c41200">u</span><span style="color:#f3c518">k</span><span style="color:#0039b6">t</span><span style="color:#30a72f">o</span><span style="color:#c41200">m</span><span style="color:#0039b6">m</span><span style="color:#c41200">y</span><span style="color:#f3c518">.</span><span style="color:#0039b6">c</span><span style="color:#30a72f">o</span><span style="color:#0039b6">m</span></a></h1>
<form id="searchbar" method="get" action="http://www.google.co.jp/search"><p>
  <input type="text" name="q" value="" size="20" maxlength="255" />
  <input type="hidden" name="ie" value="utf-8" />
  <input type="hidden" name="hl" value="ja" />
  <input type="hidden" name="domains" value="fuktommy.com" />
  <input type="hidden" name="sitesearch" value="fuktommy.com" />
</p></form>
<script type="text/javascript" src="/searchbar.js"></script>
''' % (title, cssname, mobileuri, pathname, rssuri, baseuri)


def print_footer():
    print '''<!--
<rdf:RDF
   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
   xmlns:foaf="http://xmlns.com/foaf/0.1/">
<rdf:Description rdf:about="http://blog.fuktommy.com/">
   <foaf:maker rdf:parseType="Resource">
     <foaf:holdsAccount>
       <foaf:OnlineAccount foaf:accountName="fuktommy">
         <foaf:accountServiceHomepage rdf:resource="http://www.hatena.ne.jp/" />
       </foaf:OnlineAccount>
     </foaf:holdsAccount>
   </foaf:maker>
</rdf:Description>
</rdf:RDF>
-->
<address>Copyright&copy; 1998-2007 <a href="http://fuktommy.com/">Fuktommy</a>.
All Rights Reserved.<br />
<a href="mailto:webmaster@fuktommy.com">webmaster@fuktommy.com</a>
(<a rel="license" href="http://creativecommons.org/licenses/by/2.1/jp/" title="This work is licensed under a Creative Commons Attribution 2.1 Japan License.">Legal Notices</a>)
</address>
<script type="text/javascript">
// <![CDATA[
if (location.hash.search('#e') == 0) {
    location.href = 'http://blog.fuktommy.com/' + location.hash.substr(2);
}
// ]]>
</script>
<script type="text/javascript" src="http://track3.mybloglog.com/js/jsserv.php?mblID=2006121501312191"></script>
<script src="http://www.google-analytics.com/urchin.js" type="text/javascript">
</script>
<script type="text/javascript">
_uacct = "UA-61877-8";
urchinTracker();
</script>
</body>
</html>'''


def print404(msg='404 Not Found'):
    print 'Status: 404 Not Found'
    print 'Content-Type: text/plain; charset=UTF-8'
    print
    print msg

def print_entry(entry, entry_page_mode=True):
    print '<div class="entry">'
    print '<h2><a href="%s">%s</a></h2>' % \
          (cgi.escape(permalink(entry.id), True), cgi.escape(entry.title))
    print entry.body
    print '<ul class="feedback">'
    print '<li>%s</li>' % \
          time.strftime('%Y-%m-%d %H:%M:%S', time.localtime(entry.id))
    print '<li><a href="http://b.hatena.ne.jp/entry/%s">' % \
          urllib.quote(permalink(entry.id)) + \
          'Comments' + \
          ' <img src="/b_entry_de.gif" width="16" height="12" alt="" />' +\
          ' <img src="http://b.hatena.ne.jp/entry/image/large/%s" ' % \
          urllib.quote(permalink(entry.id)) + 'alt="" /></a></li>'
    print '<li><a href="http://blogsearch.google.com/blogsearch?&amp;q=link:'+\
          urllib.quote(permalink(entry.id)) + '&amp;scoring=d">' + \
          ' Links to this Entry</a></li>'
    print '<li>[[<a href="http://bbs.shingetsu.info/" id="shingetsu_link">' + \
          '\xE6\x96\xB0\xE6\x9C\x88</a>]]</li>'
    print '</ul>'
    print '<script type="text/javascript" ' +\
          'src="http://bbs.shingetsu.info/suggest.js"></script>'
    print '<div class="ads">'
    if entry_page_mode:
#        print '''<script type="text/javascript"><!--
#google_ad_client = "pub-0908882948816599";
#google_ad_width = 468;
#google_ad_height = 60;
#google_ad_format = "468x60_as";
#google_ad_type = "text_image";
#google_ad_channel ="";
#google_color_border = "808080";
#google_color_bg = "EFEFEF";
#google_color_link = "0000FF";
#google_color_text = "000000";
#google_color_url = "008000";
#//--></script>
#<script type="text/javascript"
#  src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
#</script>'''
        print '''<script type="text/javascript"><!--
  amazon_ad_tag = "fuktommysstor-22";
  amazon_ad_width = "468";
  amazon_ad_height = "60";
  amazon_ad_logo = "hide";
  amazon_color_border = "808080";
  amazon_color_background = "EFEFEF";
  amazon_color_link = "0000FF";
  amazon_color_price = "000000";
  amazon_color_logo = "FFFFFF";
//--></script>
<script type="text/javascript" src="http://www.assoc-amazon.jp/s/ads.js"></script>'''
    else:
        print '''<script type="text/javascript">
var amazon_live_type = 13;
</script>
<script type="text/javascript" src="/data/amazon.js"></script>'''
    print '</div>'
    print '</div>'

def print_index():
    print_header(blogtitle, '', True)
    recent = recent_entry()
    recent.load()
    print_entry(recent, entry_page_mode=False)

    index = Index()
    index.load()
    print '<div id="links">'
    print '<h2>Archives</h2>'
    print '<ul id="archives">'
    for i in index:
        title = cgi.escape(i, True)
        print '<li><a href="%s%s">%s</a></li>' % (baseuri, i, i)
    print '</ul>'
    print '<script type="text/javascript" src="/archives.js"></script>'
    print '''<h2>Links</h2>
<ul>
  <li><a href="http://fuktommy.com/">Fuktommy.com</a></li>
  <li><a href="http://b.hatena.ne.jp/fuktommy/">Bookmarks</a></li>
  <li><a href="http://astore.amazon.co.jp/fuktommy-22">Books</a></li>
  <li><a href="http://mixi.jp/show_friend.pl?id=30173">mixi</a></li>
  <li><a href="http://bbs.fuktommy.com/">BBS</a></li>
  <li><a href="mailto:webmaster@fuktommy.com">Mail</a></li>
  <li><a href="http://fuktommy.com/blogch/">Download</a></li>
</ul>
<h2>Syndication</h2>
<ul>
  <li><a href="http://b.hatena.ne.jp/bookmarklist?url=http://blog.fuktommy.com/">
      Comments
      <img src="http://b.hatena.ne.jp/bc/dg/http://blog.fuktommy.com/" class="bcounter" alt="" /></a></li>
  <li><a href="/rss">
      <img src="/feed-icon-16x16.gif" width="16" height="16" alt="" />
      RSS 1.0</a></li>
  <li><a href="http://fusion.google.com/add?feedurl=http%3A//blog.fuktommy.com/rss"><img src="http://buttons.googlesyndication.com/fusion/add.gif" width="104" height="17" alt="Add to Google" /></a></li>
  <li><a href="https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&amp;business=paypal%40fuktommy%2ecom&amp;item_name=Fuktommy%2ecom&amp;amount=500&amp;no_shipping=0&amp;no_note=1&amp;tax=0&amp;currency_code=JPY&amp;bn=PP%2dDonationsBF&amp;charset=UTF%2d8"><img src="/donate.gif" alt="Make payments with PayPal" width="73" height="44" /></a></li>
  <li><a href="http://mobile.fuktommy.com/"><img src="/mobileqrcode.gif" width="132" height="132" alt="for Mobile" title="for Mobile" /></a></li>
  <li style="margin-bottom: 1ex;"><script type="text/javascript" src="http://pub.mybloglog.com/stats.php?mblID=2006121501312191&amp;width=180&amp;max_chars=20&amp;color_heading_bg=808080&amp;color_heading=FFFFFF&amp;color_link_bg=EFEFEF&amp;color_link=0000FF&amp;color_bottom_bg=EFEFEF"></script></li>
  <li><script type="text/javascript" src="http://pub.mybloglog.com/comm2.php?mblID=2006121501312191&amp;c_width=180&amp;c_sn_opt=n&amp;c_rows=10&amp;c_img_size=f&amp;c_heading_text=Recent+Readers&amp;c_color_heading_bg=808080&amp;c_color_heading=FFFFFF&amp;c_color_link_bg=EFEFEF&amp;c_color_link=0000FF&amp;c_color_bottom_bg=808080"></script></li>
</ul>
</div>'''
    print_footer()

def print_archive(month):
    archive = Month(month)
    archive.load()
    if not archive:
        print404('%s is not exists' % month)
        return
    print_header(month, month)
    print '<h2>%s</h2>' % month
    print '<ul>'
    for id, title in list(archive):
        print '<li>%s <a href="%s%s">%s</a></li>' % \
              (time.strftime('%Y-%m-%d', time.localtime(int(id))),
               baseuri, id, title)
    print '</ul>'
    print_footer()

def print_entry_page(id):
    entry = Entry(id)
    entry.load()
    if not entry:
        print404('%s is not exists' % id)
        return
    print_header(entry.title, id)
    print_entry(entry)
    print_footer()


def main():
    os.environ['TZ'] = timezone
    time.tzset()
    query = os.environ.get('QUERY_STRING', '')
    found_archive = re.search(r'^(\d{4}-\d{2})$', query)
    found_entry = re.search(r'^(\d+)$', query)
    if found_archive:
        print_archive(found_archive.group(1))
    elif found_entry:
        print_entry_page(found_entry.group(1))
    else:
        print_index()

if __name__ == '__main__':
    main()
