#!/usr/local/bin/python
#
'''Blogch2 for Mobile Agents.

Simble Blog Tool.
'''
#
# Copyright (c) 2006,2007 Satoshi Fukutomi <info@fuktommy.com>.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#

import cgitb; cgitb.enable()

import re
import os
import cgi
import sys
import time
import urllib

sys.path.append('/srv/lib/python')
from blogdata import *

#
# Config
#
#baseuri = './mobile.cgi?'
baseuri = '/blog/'
timezone = 'JST-09'
mobileuri = 'http://mobile.fuktommy.com/blog/'
bloguri = 'http://blog.fuktommy.com/'
blogtitle = 'blog.fuktommy.com'
rssuri = 'http://blog.fuktommy.com/rss'

def _blogdata():
    import blogdata
    blogdata.data_dir='/srv/data/blog.fuktommy.com/data'
_blogdata()


class MyStdout:
    mode = 'wb'

    def __init__(self, output):
        self.output = output

    def write(self, msg):
        msg = unicode(msg, 'utf-8', 'replace')
        msg = msg.encode('shift_jis', 'replace')
        self.output.write(msg)

    def flush(self):
        return self.output.flush()

    def close(self):
        return self.output.close()

    def __del__(self):
        self.close()

# End of MyStdout

sys.stdout = MyStdout(sys.stdout)


def permalink(id):
    return '%s%s' % (bloguri, id)

def mobilelink(id):
    return '%s%s' % (mobileuri, id)

def print_header(title, top=False):
    title = cgi.escape(title, True)
    ua = os.environ.get('HTTP_USER_AGENT', '')
    if 'DoCoMo/2.0' in ua:
        print 'Content-Type: application/xhtml+xml; charset=Shift_JIS'
        print
        print '<?xml version="1.0" encoding="Shift_JIS"?>'
    elif 'DoCoMo/1.0' in ua:
        print 'Content-Type: text/html; charset=Shift_JIS'
        print
    else:
        print 'Content-Type: text/html; charset=Shift_JIS'
        print
        print '<?xml version="1.0" encoding="Shift_JIS"?>'

    print '''<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML Basic 1.0//EN"
    "http://www.w3.org/TR/xhtml-basic/xhtml-basic10.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
  <meta http-equiv="content-type" content="text/html; charset=Shift_JIS" />
  <title>%s</title>
  <link rev="made" href="http://fuktommy.com/" />
  <link rel="contents" href="/" title="Top" />
  <link rel="alternate" type="application/rss+xml" title="RSS" href="%s" />
  <link rel="meta" type="application/rdf+xml" title="license" href="/license" />
</head>
<body style="background-color:#efefef;">
<h1><span style="font-size:medium;"><a href="%s" style="text-decoration:none;">%s</a></span></h1>
''' % (title, rssuri, baseuri, blogtitle)


def print_footer():
    print '''<div style="clear:both;text-align:center;">
<address>&copy; 2007 <a href="http://fuktommy.com/">Fuktommy</a>.<br />
<a href="http://creativecommons.org/licenses/by/2.1/jp/">Legal Notices</a>
</address></div>
</body>
</html>'''


def print404(msg='404 Not Found'):
    print 'Status: 404 Not Found'
    print 'Content-Type: text/plain; charset=Shift_JIS'
    print
    print msg

def print_entry(entry, entry_page_mode=True):
    body = entry.body
    body = body.replace('</p>', '<br /><br /></p>')
    body = body.replace('</pre>', '\n\n</pre>')
    print '<div class="entry">'
    print '<div style="background-color:#afa;"><h2><span style="font-size:medium;"><a href="%s">%s</a></span></h2></div>' % \
          (cgi.escape(mobilelink(entry.id), True), cgi.escape(entry.title))
    print body
    print '<ul style="border-top:solid 1px gray;border-bottom:solid 1px gray;">'
    print '<li>%s</li>' % \
          time.strftime('%Y-%m-%d %H:%M:%S', time.localtime(entry.id))
    print '<li><a href="http://b.hatena.ne.jp/entry/%s">' % \
          urllib.quote(permalink(entry.id)) + \
          'Comments' + \
          ' <img src="/blog/b_entry_de.gif" width="16" height="12" alt="" />'+\
          ' <img src="http://b.hatena.ne.jp/entry/image/large/%s" ' % \
          urllib.quote(permalink(entry.id)) + 'alt="" /></a></li>'
    print '<li><a href="http://blogsearch.google.com/blogsearch?&amp;q=link:'+\
          urllib.quote(permalink(entry.id)) + '&amp;scoring=d">' + \
          ' Links to this Entry</a></li>'
    print '</ul>'
    print '</div>'

def print_index():
    print_header(blogtitle, True)
    index = Index()
    index.load()
    print '<div id="links">'
    print '<div style="background-color:#afa;"><h2><span style="font-size:medium;">Archives</span></h2></div>'
    print '<ul id="archives">'
    for i in index:
        title = cgi.escape(i, True)
        print '<li><a href="%s%s">%s</a></li>' % (baseuri, i, i)
    print '</ul>'
    print '''<div style="background-color:#afa;"><h2><span style="font-size:medium;">Links</span></h2></div>
<ul>
  <li><a href="http://mobile.fuktommy.com/">mobile.fuktommy.com</a></li>
  <li><a href="http://b.hatena.ne.jp/fuktommy/mobile">Bookmarks</a></li>
  <li><a href="mailto:webmaster@fuktommy.com">Mail</a></li>
</ul>
</div>'''
    print_footer()

def print_archive(month):
    archive = Month(month)
    archive.load()
    if not archive:
        print404('%s is not exists' % month)
        return
    print_header(month)
    print '<div style="background-color:#afa;"><h2><span style="font-size:medium;">%s</span></h2></div>' % month
    print '<ul>'
    for id, title in list(archive):
        print '<li>%s <a href="%s%s">%s</a></li>' % \
              (time.strftime('%Y-%m-%d', time.localtime(int(id))),
               baseuri, id, title)
    print '</ul>'
    print_footer()

def print_entry_page(id):
    entry = Entry(id)
    entry.load()
    if not entry:
        print404('%s is not exists' % id)
        return
    print_header(entry.title)
    print_entry(entry)
    print_footer()


def main():
    os.environ['TZ'] = timezone
    time.tzset()
    query = os.environ.get('QUERY_STRING', '')
    found_archive = re.search(r'^(\d{4}-\d{2})$', query)
    found_entry = re.search(r'^(\d+)$', query)
    if found_archive:
        print_archive(found_archive.group(1))
    elif found_entry:
        print_entry_page(found_entry.group(1))
    else:
        print_index()

if __name__ == '__main__':
    main()
